/*
  Last changed Time-stamp: <2006-02-08 11:51:06 xtof>
  $Id: lc_options.c,v 1.1.1.1 2003/01/22 13:45:33 sonja Exp $
*/

//////////////////////////////
//
//IMPORTANT: tmp must be decoded with %d for integers and %f for floating point values
//
//////////////////////////////

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <stdarg.h>
#include <getopt.h>
#include "options.h"
#include <string>
#include <iostream>
static OptionS OptS;

static struct option const long_options[] =
{ {"help",    no_argument,       0, 'h'},
  {"verbose", no_argument,       0, 'v'},
  {"met", no_argument,       0, 0},
  {"kawa", no_argument,       0, 0},
  {"accepted_solution_count_sections",required_argument, 0,   0},
  {"add",    required_argument, 0,   0},
  {"algo",    required_argument, 0,   0},
 {"clusters",required_argument, 0,   0},
 {"centroid",required_argument, 0,   0},
  {"evaporate",required_argument, 0,   0},
 {"evaporation_threshold",required_argument, 0,   0},
  {"gafrac",required_argument, 0,   0},
  {"gbest",required_argument, 0,   0},
  {"iterations",required_argument, 0,   0},
  {"loopsize",    required_argument, 0,   0},
  {"infile",required_argument, 0,   0},
  {"particles",required_argument, 0,   0},
  {"pbest",required_argument, 0,   0},
  {"pstack",required_argument, 0,   0},
  {"random",required_argument, 0,   0},
  {"reference",required_argument, 0,   0},
  {"initial_stacksize",   required_argument, 0,   0},
  {"final_stacksize",   required_argument, 0,   0},
  {"runs",required_argument, 0,   0},
  {"search_method",required_argument, 0,   0},
  {"stemsprinted",required_argument, 0,   0},
  {"steps",required_argument, 0,   0},
  {"solutions_report_interval",required_argument, 0,   0},
  {"sv_stat_sections",required_argument, 0,   0},
  {"total_solutions",required_argument, 0,   0},
  {"swap_select",required_argument, 0,   0},
  {"transposition_count_sections",required_argument, 0,   0},
  {"alpha",    required_argument, 0,   0},
  {NULL, 0, NULL, 0}
};

/* forward declaration(s) of private function(s) */
static void initializeOptions (char *name);
static void processOptions(int argc, char *argv[]);

/* ==> public function(s) <== */
/*
 */
OptionS *
decodeCML(int argc, char *argv[]) {
  initializeOptions(argv[0]);
  processOptions(argc, argv);
  return (&OptS);
}

// OptS.centroid=0.0;
//   random =.1
//   OptS.particles    =  500;//100; 
//   OptS.iterations   =  560;//10000;
//   OptS.runs         =   100;
//   infile  "rna.txt"
//   OptS.evaporate    =  0.95;//1.0;
//   OptS.pbest        =  3.0;//2.0;
//   OptS.gbest        =  3.0;//2.0;
//   OptS.clusters     =  7;//  1;
//    OptS.swap_select=.01;//1.0;
//    OptS.steps        =  25;// 2;



/*
  print usage information to stderr and exit
*/

 // fprintf(stderr, "\nUsage: %s [OPTIONS] < SeqFile  > Outfile\n", OptS.ExeName);
//   fprintf(stderr,
//           "Options without argument:\n"
//  	  " -h, --help          Print usage information for %s.\n"
//           "--init_structure     Start with a structure other than the open chain.\n"
//    	  "--interrupt          Allow interrupted folding trajectories when the barrier is exceeded.\n"
//           "--printfront.        Creates PS plots of front progression with index i, named front_trajectory($i).ps.\n"
//      	  " -t, --test          Use test sequence.\n"
// 	  " -v, --verbose       Verbose mode. Print debugging messages about program progress.\n\n",
// 	  OptS.ExeName);
//   fprintf(stderr,
//           "Options with argument:\n"
//           "--barrier_heuristic  'M' Morgan-Higgs,'S' limits small stacks,'B' Barriers,'A' all, then take minimum. Default: >%c<\n"
//           "--dangle             Dangle value of 0,1,2 as in the ViennaRNA package. Default: >%d<\n"
// 	  "--grouping           How barrier_heuristic 'M' treats conflict groups(\"standard\" or \"regroup\"). Default: >%s<\n"
// 	  "--lookahead          #BP that MorganHiggs forms its subpaths from. Default: >%d<\n",
// 	  OptS.barrier_heuristic,OptS.dangle, OptS.grouping, OptS.lookahead);
//   fprintf(stderr,
//           "--maxkeep            Breadth of breadth first seerch in barrier_heuristic='B'. Default: >%d<\n"
//           "--nolonely           Value of noLonelyPairs as in ViennaRNA. Default: >%d<\n"
//           "--transcribed        #bases initially transcribed, <0 means all is transcribed. Default: >%d<)\n"
//           "--transcription_rate #bases transcribed per second. Default: >%f<)\n"
//           "--windowsize         Max size of substructures considered for folding events during transcription, 0= all are considered. Default: >%d<)\n",
//           OptS.maxkeep,OptS.noLonelyPairs,OptS.transcribed, OptS.transcription_rate,OptS.windowsize);
//   exit (status);

void usage(int status) {
          fprintf(stderr, "\nUsage: %s [OPTIONS] \n", OptS.ExeName);
          fprintf(stderr,
          "Options for parameter settings:\n"
	  " -h, --help    Print usage information.\n"
	  " --alpha       DOUBLE  Cooling rate, between 0 amd 1. Default: %f\n"
          " --centroid    DOUBLE  Weight of the centroid. Default: %f\n"
          " --clusters    INT     # of subswarms. Default: %d\n"
	  " --evaporate   DOUBLE  Inertia weight of stochastic vector. Default: %1.2f\n"
	  " --gbest       DOUBLE  Relative probability of global best reference structure. Default: %1.2f\n"
	  " --infile      STRING  Input file with sequence and centroid structure. Default: %s\n",
	  OptS.alpha,OptS.centroid,OptS.clusters,OptS.evaporate,OptS.gbest,OptS.infile);

          fprintf(stderr,
	  " --iterations  INT     Iterations of search algorithm. Default: %d\n"
	  " --particles   INT     Swarm size. Default: %d\n"
	  " --pbest       DOUBLE  Relative probability of personal best reference structure. Default: %1.2f\n"
	  " --random      DOUBLE  Probability of making a random movement. Default: %1.2f\n"
          " --runs        INT     # of times to run the algorithm. Default: %d\n"
	  " --steps       INT     Number of swaps a particle can execute per iteration. Default: %d\n"         
	  " --swap_select DOUBLE  Probability with which a viable transposition is selected (HelixPso::MoveTowards). Default: %f\n"
	  " --total_solutions INT # solutions after which algorithms terminates. Default: %d\n",
		  OptS.iterations,OptS.particles,OptS.pbest,OptS.random,OptS.runs,OptS.steps,OptS.swap_select,OptS.total_solutions);

   



        //   fprintf(stderr,
//           "Options for printouts and statistics (developers):\n"
//           " --accepted_solution_count_sections      INT how many intervals to separate the total_solutions into when counting accepted solutions .Default: %d\n"
//           " --solutions_report_interval             INT every nth solution will be reported when evaluating runs.Default: %d\n"
// 	  " --stemsprinted                          INT How many stem indices RNAPRedict will print in its population listings: %d\n"
//           " --sv_stat_sections                      INT states whether statistics on the stochastic vector are desired.>0 means yes.Default: %d\n"
// 	  " --transposition_count_sections          INT how many intervals to separate the total_solutions into when counting transposition indices .Default: %d\n\n",
// 	  OptS.accepted_solution_count_sections,OptS.solutions_report_interval ,OptS.stemsprinted,OptS.sv_stat_sections,OptS.transposition_count_sections);


	  //DEPRECATED
          // fprintf(stderr,
//           "Options related to RNA secondary structure:\n"
//           " --final_stacksize   INT     Set final minimal stack size. Default: %d\n"	 
//           " --initial_stacksize INT     Set initial minimal stack size. Default: %d\n"
// 	  " --loopsize          INT     Set minimal loop size to int. Default: %d\n\n",
// 	    OptS.final_stacksize,OptS.initial_stacksize,OptS.loopsize);
//           fprintf(stderr,
//           "Deprecated Options, which may or may not still do what they originally were created for. Use at your own risk(developers):\n"
//           " --add                    DOUBLE  Probability of adding (vs.removing) base pairs. Default: %1.2f\n"
//           " --algo                   CHAR*  Name of the algorithm to use: RNAPREDICT or HELIXPSO(default)\n"
// 	  " --evaporation_threshold  DOUBLE  cutoff value for probabilities in stochastic reference vector. Default: %1.2f\n"
//           " --gafrac                 DOUBLE Fraction of solutions generated by the GA for the hybrid algorithm. Default: %1.2f\n"
// 	  " --pstack                 DOUBLE  Probability bonus for basepairs that help form a stack. Default: %1.2f\n"
// 	  " --reference              INT     Set minimal reference stack size to int. Default: %d\n"
// 	  " --search_method          String Currently greedy or nongreedy Default: %s\n"
// 	  " --total_solutions        INT     Number of solutions to generate until the algorithm stops.Default: %d\n",
// 	  OptS.add,OptS.evaporation_threshold, OptS.gafrac,OptS.pstack,OptS.reference,OptS.search_method,OptS.total_solutions);

  exit (status);
}

/*
  call example:
  fatal("calloc(): out of memory when requesting %d bytes", numbytes)
*/
void fatal ( char *fmt, ... ) {
  va_list args;
  
  va_start( args, fmt );
  fprintf( stderr, "\nFATAL ERROR: ");
  vfprintf( stderr, fmt, args);
  fprintf( stderr,"\n");
  va_end( args );
  exit( EXIT_FAILURE );
}

/*
  call example:
  same as fatal()
 */
void warn ( char *fmt, ... ) {
  va_list args;
  
  va_start( args, fmt );
  fprintf( stderr, "\nWARNING: ");
  vfprintf( stderr, fmt, args);
  fprintf( stderr,"\n");
  va_end( args );
}

/* ==> private function(s) <== */
/*
  set otions to default value(s)
*/
static void initializeOptions (char *name) {
  OptS.alpha=0.95;


  strcpy(OptS.ExeName, name);
  OptS.add          =  .85;
  OptS.loopsize     =   3;
  OptS.pstack       =  .2;
  OptS.random       =  .1;
  OptS.reference    =   3;
  OptS.initial_stacksize=2;
  OptS.final_stacksize  =2;
  OptS.steps        =  25;

  //generic
  OptS.testseq      =   0;
  OptS.verbose      =   0;
  OptS.stemsprinted = 20; 
  OptS.total_solutions=100000;//280000;
  
  OptS.solutions_report_interval=10000;
  OptS.centroid=0.0;

  
  //fixed
  OptS.particles    =  500;
  OptS.iterations   =  560;
  OptS.runs         =  1;//300;
  strcpy(OptS.infile,"rna.txt");
  OptS.evaporation_threshold   =.05;//2;
  //variable
  OptS.evaporate    =  0.95;//1.0;
  OptS.pbest        =  3.0;//2.0;
  OptS.gbest        =  3.0;//2.0;
  OptS.clusters     =  7;//  1;

  strcpy(OptS.search_method,"transposition");
  strcpy(OptS.algo,"HELIXPSO");
   

 OptS.gafrac=0.0;//.02;//0.0;
 OptS.swap_select=.01;//1.0;
 OptS.transposition_count_sections=0;
 OptS.accepted_solution_count_sections=0;
 OptS.sv_stat_sections=0;
 OptS.rule=0;
}



/*
  process command-line options and update global structure OptS
*/
static void processOptions(int argc, char *argv[]) {
  int c, option_index = 0;

  while ((c = getopt_long (argc, argv, "htv", 
			   long_options, &option_index)) != EOF) {
    switch (c) {
    case 0:
 if (strcmp(long_options[option_index].name, "alpha")==0) {
	float tmp;
	if (sscanf(optarg, "%f", &tmp) == 0) {
	  warn ("Option requires argument: No P(add) specified");
	  usage (EXIT_FAILURE);
	}
	else { OptS.alpha = tmp; }
       }


      if (strcmp(long_options[option_index].name, "accepted_solution_count_sections")==0) {
	int tmp;
	if (sscanf(optarg, "%d", &tmp) == 0) {
	  warn ("Option requires argument: No accepted_solution_count_sections specified");
	  usage (EXIT_FAILURE);
	}
	else { OptS.accepted_solution_count_sections = tmp; }
      }
       if (strcmp(long_options[option_index].name, "add")==0) {
	float tmp;
	if (sscanf(optarg, "%f", &tmp) == 0) {
	  warn ("Option requires argument: No P(add) specified");
	  usage (EXIT_FAILURE);
	}
	else { OptS.add = tmp; }
       }
       if (strcmp(long_options[option_index].name, "algo")==0) {
	 std::string tmp=std::string();
	if (sscanf(optarg, "%s", &tmp[0]) == 0) {
	  warn ("Option requires argument: No algo");
	  usage (EXIT_FAILURE);
	}
	else { strcpy(OptS.algo,tmp.c_str());}
      }
        if (strcmp(long_options[option_index].name, "clusters")==0) {
	int tmp;
	if (sscanf(optarg, "%d", &tmp) == 0) {
	  warn ("Option requires argument: No # cluster specified");
	  usage (EXIT_FAILURE);
	}
	else { OptS.clusters = tmp; }
       }
       if (strcmp(long_options[option_index].name, "centroid")==0) {
	float tmp;
	if (sscanf(optarg, "%f", &tmp) == 0) {
	  warn ("Option requires argument: No centroid weight specified");
	  usage (EXIT_FAILURE);
	}
	else { OptS.centroid = tmp; }
      }

      if (strcmp(long_options[option_index].name, "evaporate")==0) {
	float tmp;
	if (sscanf(optarg, "%f", &tmp) == 0) {
	  warn ("Option requires argument: No evaporation factor specified");
	  usage (EXIT_FAILURE);
	}
	else { OptS.evaporate = tmp; }
      }
      if (strcmp(long_options[option_index].name, "evaporation_threshold")==0) {
	float tmp;
	if (sscanf(optarg, "%f", &tmp) == 0) {
	  warn ("Option requires argument: No evaporation_threshold specified");
	  usage (EXIT_FAILURE);
	}
	else { OptS.evaporation_threshold = tmp; }
      }
      if (strcmp(long_options[option_index].name, "gafrac")==0) {
	float tmp;
	if (sscanf(optarg, "%f", &tmp) == 0) {
	  warn ("Option requires argument: No gafrac specified");
	  usage (EXIT_FAILURE);
	}
	else { OptS.gafrac = tmp; }
      }
     
      if (strcmp(long_options[option_index].name, "gbest")==0) {
	float tmp;
	if (sscanf(optarg, "%f", &tmp) == 0) {
	  warn ("Option requires argument: No gbest specified");
	  usage (EXIT_FAILURE);
	}
	else { OptS.gbest = tmp; }
      }

   
      if (strcmp(long_options[option_index].name, "iterations")==0) {
	int tmp;
	if (sscanf(optarg, "%d", &tmp) == 0) {
	  warn ("Option requires argument: No iterations specified");
	  usage (EXIT_FAILURE);
	}
	else { OptS.iterations = tmp; }
       }

      if (strcmp(long_options[option_index].name, "loopsize")==0) {
	int tmp;
	if (sscanf(optarg, "%d", &tmp) == 0) {
	  warn ("Option requires argument: No minimal loop size specified");
	  usage (EXIT_FAILURE);
	}
	else { OptS.loopsize = tmp; }
      }
      if (strcmp(long_options[option_index].name, "infile")==0) {
	 std::string tmp=std::string();
	if (sscanf(optarg, "%s", &tmp[0]) == 0) {
	  warn ("Option requires argument: No infile");
	  usage (EXIT_FAILURE);
	}
	else { strcpy(OptS.infile,tmp.c_str()); }
      }

      if (strcmp(long_options[option_index].name, "particles")==0) {
	int tmp;
	if (sscanf(optarg, "%d", &tmp) == 0) {
	  warn ("Option requires argument: No # particles specified");
	  usage (EXIT_FAILURE);
	}
	else { OptS.particles = tmp; }
      }

      if (strcmp(long_options[option_index].name, "pbest")==0) {
	float tmp;
	if (sscanf(optarg, "%f", &tmp) == 0) {
	  warn ("Option requires argument: No pbest specified");
	  usage (EXIT_FAILURE);
	}
	else { OptS.pbest = tmp; }
      }

      if (strcmp(long_options[option_index].name, "pstack")==0) {
	float tmp;
	if (sscanf(optarg, "%f", &tmp) == 0) {
	  warn ("Option requires argument: No p bonus for stacks specified");
	  usage (EXIT_FAILURE);
	}
	else { OptS.pstack = tmp; }
      }

      if (strcmp(long_options[option_index].name, "random")==0) {
	float tmp;
	if (sscanf(optarg, "%f", &tmp) == 0) {
	  warn ("Option requires argument: No P(random move) specified");
	  usage (EXIT_FAILURE);
	}
	else { OptS.random = tmp; }
      }
      if (strcmp(long_options[option_index].name, "reference")==0) {
	int tmp;
	if (sscanf(optarg, "%d", &tmp) == 0) {
	  warn ("Option requires argument: No min size for reference conformations specified");
	  usage (EXIT_FAILURE);
	}
	else { OptS.reference = tmp; }
      }
      if (strcmp(long_options[option_index].name, "runs")==0) {
	int tmp;
	if (sscanf(optarg, "%d", &tmp) == 0) {
	  warn ("Option requires argument: No number of runs specified");
	  usage (EXIT_FAILURE);
	}
	else { OptS.runs = tmp; }
      }

      if (strcmp(long_options[option_index].name, "initial_stacksize")==0) {
	int tmp;
	if (sscanf(optarg, "%d", &tmp) == 0) {
	  warn ("Option requires argument: No initial minimal stack size specified");
	  usage (EXIT_FAILURE);
	}
	else { OptS.initial_stacksize = tmp; }
      }
      if (strcmp(long_options[option_index].name, "final_stacksize")==0) {
	int tmp;
	if (sscanf(optarg, "%d", &tmp) == 0) {
	  warn ("Option requires argument: No final minimal stack size specified");
	  usage (EXIT_FAILURE);
	}
	else { OptS.final_stacksize = tmp; }
      }

      if (strcmp(long_options[option_index].name, "search_method")==0) {
        std::string tmp=std::string();
	if (sscanf(optarg, "%s", &tmp[0]) == 0) {
	  warn ("Option requires argument: No search_method specified");
	  usage (EXIT_FAILURE);
	}
	else { strcpy(OptS.search_method,tmp.c_str()); }
      }


      if (strcmp(long_options[option_index].name, "steps")==0) {
	int tmp;
	if (sscanf(optarg, "%d", &tmp) == 0) {
	  warn ("Option requires argument: No number of steps per turn specified");
	  usage (EXIT_FAILURE);
	}
	else { OptS.steps = tmp; }
      }

      if (strcmp(long_options[option_index].name, "stemsprinted")==0) {
	int tmp;
	if (sscanf(optarg, "%d", &tmp) == 0) {
	  warn ("Option requires argument: No number of stems to print specified");
	  usage (EXIT_FAILURE);
	}
	else { OptS.stemsprinted = tmp; }
      }
      
      if (strcmp(long_options[option_index].name, "solutions_report_interval")==0) {
	int tmp;
	if (sscanf(optarg, "%d", &tmp) == 0) {
	  warn ("Option requires argument: No solutions_report_interval value specified");
	  usage (EXIT_FAILURE);
	}
	else { OptS.solutions_report_interval = tmp; }
      }

      if (strcmp(long_options[option_index].name, "sv_stat_sections")==0) {
	int tmp;
	if (sscanf(optarg, "%d", &tmp) == 0) {
	  warn ("Option requires argument: No sv_stat_sections_value specified");
	  usage (EXIT_FAILURE);
	}
	else { OptS.sv_stat_sections = tmp; }
      }


      if (strcmp(long_options[option_index].name, "total_solutions")==0) {
	int tmp;
	if (sscanf(optarg, "%d", &tmp) == 0) {
	  warn ("Option requires argument: No number for total_solutions specified");
	  usage (EXIT_FAILURE);
	}
	else { OptS.total_solutions = tmp; }
      }
      if (strcmp(long_options[option_index].name, "swap_select")==0) {
	float tmp;
	if (sscanf(optarg, "%f", &tmp) == 0) {
	  warn ("Option requires argument: No swap_select specified");
	  usage (EXIT_FAILURE);
	}
	else { OptS.swap_select = tmp; }
      }
      if (strcmp(long_options[option_index].name, "transposition_count_sections")==0) {
	int tmp;
	if (sscanf(optarg, "%d", &tmp) == 0) {
	  warn ("Option requires argument: No transposition_count_sections specified");
	  usage (EXIT_FAILURE);
	}
	else { OptS.transposition_count_sections = tmp; }
      }
      if (strcmp(long_options[option_index].name, "verbose")==0) OptS.verbose = 1;
      if (strcmp(long_options[option_index].name, "test"   )==0) OptS.testseq = 1;
      if (strcmp(long_options[option_index].name, "kawa"   )==0) OptS.rule = 1;
      if (strcmp(long_options[option_index].name, "met"   )==0) OptS.rule = 2;

      break;
    case 'h':
      usage (EXIT_SUCCESS);
      break;
    case 'v':
      OptS.verbose++;
      break;
    case 't':
      OptS.testseq = 1;
      break;
    default:
      usage (EXIT_FAILURE);
    }
  }

#if 0
  /* parse the to file names from the remaining command-line */
  if ( (optind + 2) <= argc) {
    strcpy(OptS.PhylipFile,  argv[optind++]);
    strcpy(OptS.DumpFile,    argv[optind++]);
  }
  else {
    warn ("Not enough Input Files. (Need a Phylip AND a Dump File)");
    usage(EXIT_FAILURE);
  }
#endif
}

/* End of file */
